Subject: Re: linux-next: build failure after merge all the trees

From: Mauro Carvalho Chehab <[email-masked]>
Date: Thu, 8 May 2025 14:39:11 +0200

Em Thu, 8 May 2025 22:25:31 +1000
Stephen Rothwell <[email-masked]> escreveu:

> Hi Akira,
> 
> On Thu, 8 May 2025 19:54:08 +0900 Akira Yokosawa <[email-masked]> wrote:
> >
> > Please try:
> > 
> >   make O="$HOME/next/htmldocs" KERNELDOC=scripts/kernel-doc.pl htmldocs
> > 
> > , assuming your $HOME/next/next is the top of kernel source.
> > 
> > I'm suspecting that the conflict resolution done in
> > c84724f2137f ("Merge branch 'for-6.16/tsm-mr' into tsm-next")
> > ended up in mismatching path names given to "kernel-doc::" somewhere.
> > 
> > Looks like recent conversion of the kernel-doc script into python
> > has changed the behavior in such error conditions.
> > With the perl version, you'll see a couple of:
> > 
> >     Error: Cannot open file <...>/linux/drivers/virt/coco/tsm-mr.c
> > 
> > , but the doc build should complete.  
> 
> OK, so, yes, the build completes.  I get the following message
> (multiple similar ones):
> 
> WARNING: kernel-doc 'scripts/kernel-doc.pl -rst -enable-lineno -export -export-file drivers/misc/mei/bus.c drivers/misc/mei/bus.c' processing failed with: [Errno 2] No such file or directory: 'scripts/kernel-doc.pl'
> 
> So, I used "KERNELDOC=$(pwd)/scripts/kernel-doc.pl" and tried again.
> 
> I got these (new) messages:
> 
> Error: Cannot open file drivers/virt/coco/tsm-mr.c
> Error: Cannot open file drivers/virt/coco/tsm-mr.c
> WARNING: kernel-doc 'scripts/kernel-doc.pl -rst -enable-lineno -export drivers/virt/coco/tsm-mr.c' failed with return code 2
> 
> (and a few other innocuous ones)
> 
> So your guess is good.
> 
> It would be nice to have the Python kernel-doc fixed as well as the
> devsec-tsm tree.

With regards to kernel-doc, failing to build if a file is missing
is the right thing to do. As kernel-doc is now fully an Sphinx extension,
it now signalizes to Sphinx that the build has failed. 

Yet, it should have produced some warnings. Maybe we need to specify a
different log level with Sphinx to make it happen. I'll double check it
and send a fix later on to kernel-doc.

Thanks,
Mauro